# each-series-async [![NPM version](https://img.shields.io/npm/v/each-series-async.svg?style=flat)](https://www.npmjs.com/package/each-series-async) [![NPM monthly downloads](https://img.shields.io/npm/dm/each-series-async.svg?style=flat)](https://npmjs.org/package/each-series-async) [![NPM total downloads](https://img.shields.io/npm/dt/each-series-async.svg?style=flat)](https://npmjs.org/package/each-series-async) [![Linux Build Status](https://img.shields.io/travis/jonschlinkert/each-series-async.svg?style=flat&label=Travis)](https://travis-ci.org/jonschlinkert/each-series-async)

> Asynchronously calls a function on each element in an array in series.

Follow this project's author, [Jon Schlinkert](https://github.com/jonschlinkert), for updates on this project and others.

## Install

Install with [npm](https://www.npmjs.com/):

```sh
$ npm install --save each-series-async
```

## Usage

```js
var each = require('each-series-async');
var result = [];

each([1, 2, 3, 4, 5, 6], function(ele, next) {
  result.push(ele * (i + 1));
  next(null, result);
}, function (err) {
  console.log(result);
  //=> [ 1, 4, 9, 16, 25, 36 ]
});
```

## About

### Related projects

You might also be interested in these projects:

* [arr-flatten](https://www.npmjs.com/package/arr-flatten): Recursively flatten an array or arrays. | [homepage](https://github.com/jonschlinkert/arr-flatten "Recursively flatten an array or arrays.")
* [arr-reduce](https://www.npmjs.com/package/arr-reduce): Fast array reduce that also loops over sparse elements. | [homepage](https://github.com/jonschlinkert/arr-reduce "Fast array reduce that also loops over sparse elements.")
* [array-unique](https://www.npmjs.com/package/array-unique): Remove duplicate values from an array. Fastest ES5 implementation. | [homepage](https://github.com/jonschlinkert/array-unique "Remove duplicate values from an array. Fastest ES5 implementation.")
* [async-array-reduce](https://www.npmjs.com/package/async-array-reduce): Async array reduce. Asynchronously applies a function against an accumulator and each element in an… [more](https://github.com/jonschlinkert/async-array-reduce) | [homepage](https://github.com/jonschlinkert/async-array-reduce "Async array reduce. Asynchronously applies a function against an accumulator and each element in an array (from left to right, in series) to reduce it to a single value.")

### Contributing

Pull requests and stars are always welcome. For bugs and feature requests, [please create an issue](../../issues/new).

### Building docs

_(This project's readme.md is generated by [verb](https://github.com/verbose/verb-generate-readme), please don't edit the readme directly. Any changes to the readme must be made in the [.verb.md](.verb.md) readme template.)_

To generate the readme, run the following command:

```sh
$ npm install -g verbose/verb#dev verb-generate-readme && verb
```

### Running tests

Running and reviewing unit tests is a great way to get familiarized with a library and its API. You can install dependencies and run tests with the following command:

```sh
$ npm install && npm test
```

### Author

**Jon Schlinkert**

* [github/jonschlinkert](https://github.com/jonschlinkert)
* [twitter/jonschlinkert](https://twitter.com/jonschlinkert)

### License

Copyright © 2017, [Jon Schlinkert](https://github.com/jonschlinkert).
Released under the [MIT License](LICENSE).

***

_This file was generated by [verb-generate-readme](https://github.com/verbose/verb-generate-readme), v0.6.0, on September 10, 2017._